## basix 0.0.1~git20210122.4f10ef2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

project(basix VERSION "0.0.1")
# set(CMAKE_BUILD_TYPE Debug)

# Define CMAKE_INSTALL_xxx: LIBDIR, INCLUDEDIR
include(GNUInstallDirs)

# Currently, Scikit-build does not support FindPython, so we convert the
# provided hints ourselves.
if(SKBUILD)
   set(Python_EXECUTABLE "${PYTHON_EXECUTABLE}")
   set(Python_INCLUDE_DIR "${PYTHON_INCLUDE_DIR}")
   set(Python_LIBRARY "${PYTHON_LIBRARY}")
endif()

set(Python_FIND_IMPLEMENTATIONS CPython PyPy)
find_package(Python REQUIRED COMPONENTS Interpreter Development)

# Set C++ standard before finding pybind11
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Get pybind11 CMake dir
execute_process(
  COMMAND
    "${Python_EXECUTABLE}" -c
    "import pybind11; print(pybind11.get_cmake_dir())"
  OUTPUT_VARIABLE _tmp_cmake_dir
  OUTPUT_STRIP_TRAILING_WHITESPACE COMMAND_ECHO STDOUT ECHO_OUTPUT_VARIABLE
  ECHO_ERROR_VARIABLE)
list(APPEND CMAKE_PREFIX_PATH "${_tmp_cmake_dir}")

find_package(Eigen3 REQUIRED)
message(STATUS "Found Eigen ${EIGEN3_INCLUDE_DIRS}")
include_directories(SYSTEM ${EIGEN3_INCLUDE_DIRS})

# Now we can find pybind11
find_package(pybind11 CONFIG REQUIRED)

add_subdirectory(cpp)

pybind11_add_module(_basixcpp MODULE cpp/wrapper.cpp)

set_target_properties(_basixcpp PROPERTIES SKIP_BUILD_RPATH FALSE)
set_target_properties(_basixcpp PROPERTIES BUILD_WITH_INSTALL_RPATH TRUE)
set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

if (APPLE)
  set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "@loader_path/lib")
else()
  set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "$ORIGIN/lib")
endif()

target_link_libraries(_basixcpp PRIVATE pybind11::module basix)

set_target_properties(basix PROPERTIES PUBLIC_HEADER "cpp/basix.h")

install(TARGETS _basixcpp DESTINATION .)
install(TARGETS basix
		LIBRARY DESTINATION lib
		PUBLIC_HEADER DESTINATION include)

=== cpp/CMakeLists.txt ===
# Copyright (c) 2020 Chris Richardson
# FEniCS Project
# SPDX-License-Identifier: MIT

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wno-comment -Wall -Werror -std=c++17" HAVE_NO_MULTLINE)
if (HAVE_NO_MULTLINE)
  set(CMAKE_CXX_FLAGS "-Wno-comment -Wall -Werror -std=c++17 ${CMAKE_CXX_FLAGS}")
endif()

# Executable
add_library(basix SHARED lattice.cpp polyset.cpp dof-permutations.cpp
                          moments.cpp lagrange.cpp finite-element.cpp
                          quadrature.cpp brezzi-douglas-marini.cpp
                          nedelec.cpp raviart-thomas.cpp cell.cpp regge.cpp
                          crouzeix-raviart.cpp basix.cpp)
target_compile_definitions(basix PRIVATE BASIX_VERSION=${PROJECT_VERSION})
target_compile_definitions(basix PUBLIC EIGEN_MAX_ALIGN_BYTES=32)

=== debian/changelog ===
basix (0.0.1~git20210122.4f10ef2-2) unstable; urgency=medium

  * document the need to split libbasix.so out of the python module
    into libbasix-dev and libbasix0 in README.Debian
  * debian patch test_permutation_nedelec_32bit_xfail.patch marks
    test_permutation_of_tabulated_data_tetrahedron on 32-bit systems
    with the "Nedelec 2nd kind H(curl)" [order 5] element as expected
    to fail. Treat this element as unsupported on 32-bit systems.
    Issue tracked at Bug#981901.
  * mark libbasix-dev, libbasix0 as Multi-Arch: same,
    basix-doc as Multi-Arch: foreign

 -- Drew Parsons <dparsons@debian.org>  Thu, 04 Feb 2021 22:41:26 +0100

basix (0.0.1~git20210122.4f10ef2-1) unstable; urgency=medium

  * Initial release (Closes: #981046)
  * Provide header file and libbasix.so* in libbasix-dev and libbasix0
    separated from python installation. Otherwise dh_python3 tags
    libbasix.so with a cython tag which will confuse ld.
  * add debian patches:
    - cmake_shared_library.patch
      adds SOVERSION to shared library and installs in
      ${CMAKE_INSTALL_LIBDIR} (i.e. arch-specific in usr/lib/<arch>)
    - include_path.patch
      configures basix python module's get_include_path() to
      "/usr/include", where basix.h has been installed.
  * exclude test_include from build-time tests
    (since /usr/include/basix.h not yet installed)

 -- Drew Parsons <dparsons@debian.org>  Tue, 26 Jan 2021 16:19:16 +0100

=== debian/control ===
Source: basix
Section: python
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-python,
 python3-setuptools,
 python3-all-dev,
 python3-fiat,
 python3-numpy,
 python3-pybind11 (>=2.6.0~),
 python3-pytest,
 python3-skbuild,
 python3-sympy,
 python3-wheel,
 cmake,
 chrpath,
 cython3,
 libeigen3-dev,
 libjs-mathjax,
 ninja-build
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.5.1
Homepage: https://github.com/FEniCS/basix
Vcs-Browser: https://salsa.debian.org/science-team/fenics/basix
Vcs-Git: https://salsa.debian.org/science-team/fenics/basix.git
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: libbasix-dev
Architecture: any
Multi-Arch: same
Depends: libbasix0 (= ${binary:Version}),
 libeigen3-dev,
 ${misc:Depends}, ${shlibs:Depends}
Suggests: python3-basix, basix-doc
Description: Finite Element Basis Function Definition Runtime Library (development headers)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the development files for the shared library.

Package: libbasix0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: basix-doc
Description: Finite Element Basis Function Definition Runtime Library (Python 3)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the shared library.

Package: python3-basix
Architecture: any
Depends: libbasix-dev  (= ${binary:Version}),
 ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Suggests: basix-doc
Description: Finite Element Basis Function Definition Runtime Library (Python 3)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the library for Python 3.

Package: basix-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax, ${misc:Depends}
Suggests: python3-basix
Description: Finite Element Basis Function Definition Runtime Library (docs)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

VERSION := $(DEB_STRIPPED_UPSTREAM_VERSION)
MAJOR_VERSION := $(shell echo $(DEB_STRIPPED_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
SOVERSION := $(MAJOR_VERSION)

PY3VER_DEFAULT := $(shell py3versions -dv)

export PYBUILD_NAME=basix

export PYBUILD_TEST_ARGS=-k "not test_include"

%:
	dh $@ --with python3 --buildsystem=pybuild


override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html doc/latex
	rm -rf cpp/fenics_basix.egg-info

override_dh_auto_build-indep: export http_proxy=127.0.0.1:9
override_dh_auto_build-indep: export https_proxy=127.0.0.1:9
override_dh_auto_build-indep:
	dh_auto_build -i
	cd doc; doxygen

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	cp -a _skbuild/*${PY3VER_DEFAULT}/cmake-install/cpp/basix/lib/* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/python3-basix/usr/lib/python${PY3VER_DEFAULT}/dist-packages/basix/include debian/tmp/usr
	rm -rf debian/python3-basix/usr/lib/python*/dist-packages/basix/lib
	chrpath -d debian/python3-basix/usr/lib/python*/dist-packages/basix/_basixcpp.*.so

override_dh_installdocs-indep:
	dh_installdocs -i
	grep "http://cdn.mathjax.org/mathjax/latest/MathJax.js" debian/basix-doc/usr/share/doc/basix-doc/* -r --files-with-matches | xargs sed "s|src=\"http://cdn.mathjax.org/mathjax/latest/MathJax.js|src=\"file://usr/share/javascript/mathjax/MathJax.js|g" -i

=== debian/tests/control ===
Test-Command: pytest-3
Depends: python3-basix,
 python3-pytest,
 python3-fiat,
 python3-numpy,
 python3-sympy

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%basix-$1.tar.gz%" \
   https://github.com/FEniCS/basix/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
